///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2014 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using System;

using com.espertech.esper.client;
using com.espertech.esper.client.scopetest;
using com.espertech.esper.compat;
using com.espertech.esper.compat.collections;
using com.espertech.esper.metrics.instrumentation;
using com.espertech.esper.support.bean;
using com.espertech.esper.support.client;
using com.espertech.esper.support.epl;

using java.math;

using NUnit.Framework;

namespace com.espertech.esper.regression.view
{
    [TestFixture]
    public class TestBigNumberSupportMathContext 
    {
        private EPServiceProvider epService;
        private SupportUpdateListener listener;
    
        [SetUp]
        public void SetUp()
        {
            Configuration configuration = SupportConfigFactory.Configuration;
            configuration.EngineDefaults.Expression.MathContext = MathContext.DECIMAL32;
            epService = EPServiceProviderManager.GetDefaultProvider(configuration);
            epService.Initialize();
            if (InstrumentationHelper.ENABLED) { InstrumentationHelper.StartTest(epService, this.GetType(), Name);}
            listener = new SupportUpdateListener();
            epService.EPAdministrator.Configuration.AddEventType("SupportBean", typeof(SupportBean));
        }
    
        [TearDown]
        public void TearDown() {
            if (InstrumentationHelper.ENABLED) { InstrumentationHelper.EndTest();}
            listener = null;
        }
    
        [Test]
        public void TestMathContextDivide()
        {
            // cast and divide
            EPStatement stmtDivide = epService.EPAdministrator.CreateEPL("Select cast(1.6, BigDecimal) / cast(9.2, BigDecimal) from SupportBean");
            stmtDivide.Subscriber = new ProxyObject() {
                ProcUpdate = (value) =},  {}
            };
            epService.EPRuntime.SendEvent(new SupportBean());
        }
    }
}
