///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2013 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using com.espertech.esper.compat.collections;
using com.espertech.esper.filter;

namespace com.espertech.esper.core.context.mgr
{
    public class AgentInstanceFilterProxyImpl : AgentInstanceFilterProxy
    {
        private readonly FilterSpecCompiled[] _compiledArr;
        private readonly FilterValueSetParam[][] _addendumArr;
        private readonly IdentityDictionary<FilterSpecCompiled, FilterValueSetParam[]> _addendumMap;

        public AgentInstanceFilterProxyImpl(IdentityDictionary<FilterSpecCompiled, FilterValueSetParam[]> addendums)
        {
            if (addendums.Count > 6)
            {
                _addendumMap = addendums;
                _compiledArr = null;
                _addendumArr = null;
            }
            else
            {
                _compiledArr = new FilterSpecCompiled[addendums.Count];
                _addendumArr = new FilterValueSetParam[addendums.Count][];
                int count = 0;
                foreach (var entry in addendums)
                {
                    _compiledArr[count] = entry.Key;
                    _addendumArr[count] = entry.Value;
                    count++;
                }
                _addendumMap = null;
            }
        }
    
        public FilterValueSetParam[] GetAddendumFilters(FilterSpecCompiled filterSpec)
        {
            if (_addendumMap == null)
            {
                for (int i = 0; i < _compiledArr.Length; i++)
                {
                    if (filterSpec == _compiledArr[i]) 
                    {
                        return _addendumArr[i];
                    }
                }
                return null;
            }
            else
            {
                return _addendumMap.Get(filterSpec);
            }
        }
    }
}
