///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2013 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using System;

using com.espertech.esper.compat.collections;
using com.espertech.esper.filter;

namespace com.espertech.esper.core.context.mgr
{
    public class ContextInternalFilterAddendum
    {
        private readonly IdentityDictionary<FilterSpecCompiled, FilterValueSetParam[]> _filterAddendum;

        public ContextInternalFilterAddendum()
        {
            _filterAddendum = new IdentityDictionary<FilterSpecCompiled, FilterValueSetParam[]>();
        }

        public FilterValueSetParam[] GetFilterAddendum(FilterSpecCompiled filterSpecCompiled)
        {
            return _filterAddendum.Get(filterSpecCompiled);
        }

        public IdentityDictionary<FilterSpecCompiled, FilterValueSetParam[]> FilterAddendum
        {
            get { return _filterAddendum; }
        }

        public ContextInternalFilterAddendum DeepCopy()
        {
            var copy = new ContextInternalFilterAddendum();
            foreach (var entry in _filterAddendum)
            {
                var copyList = new FilterValueSetParam[entry.Value.Length];
                Array.Copy(entry.Value, 0, copyList, 0, copyList.Length);
                copy._filterAddendum.Put(entry.Key, copyList);
            }
            return copy;
        }
    }
}