///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2011 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using System;

using com.espertech.esper.dataflow.util;

namespace com.espertech.esper.dataflow.core
{
    public class EPDataFlowEmitter1Stream1TargetPassAlongWStream 
        : EPDataFlowEmitter1Stream1TargetPassAlong
    {
        private readonly int _streamNum;

        public EPDataFlowEmitter1Stream1TargetPassAlongWStream(int operatorNum, DataFlowSignalManager signalManager, SignalHandler signalHandler, EPDataFlowEmitterExceptionHandler exceptionHandler, ObjectBindingPair target, int streamNum)
            : base(operatorNum, signalManager, signalHandler, exceptionHandler, target)
        {
            _streamNum = streamNum;
        }

        public override void SubmitInternal(Object @object)
        {
            var parameters = new Object[] { _streamNum, @object };
            try
            {
                ExceptionHandler.HandleAudit(TargetObject, parameters);
                FastMethod.Invoke(TargetObject, parameters);
            }
            catch (Exception e)
            {
                ExceptionHandler.HandleException(TargetObject, FastMethod, e, parameters);
            }
        }
    }
}
