///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2012 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////


using System;

using com.espertech.esper.collection;

namespace com.espertech.esper.epl.core
{
	
	/// <summary> Exception to indicate that a property name used in a filter doesn't resolve.</summary>
    [Serializable]
    public class PropertyNotFoundException : StreamTypesException
    {
        /// <summary>
        /// Ctor.
        /// </summary>
        /// <param name="msg">message</param>
        /// <param name="nearestMatchSuggestion">optional suggestion for a matching name</param>
        public PropertyNotFoundException(String msg, Pair<int, String> nearestMatchSuggestion)
            : base(msg, nearestMatchSuggestion)
        {
        }
    }
}
