///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2014 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using System;

using com.espertech.esper.client;
using com.espertech.esper.compat;
using com.espertech.esper.compat.collections;
using com.espertech.esper.epl.expression.core;
using com.espertech.esper.epl.table.mgmt;
using com.espertech.esper.epl.table.onaction;

namespace com.espertech.esper.epl.table.merge
{
    public class TableOnMergeActionDel : TableOnMergeAction
    {
        public TableOnMergeActionDel(ExprEvaluator optionalFilter)
            : base(optionalFilter)
        {
        }
    
        public override void Apply(EventBean matchingEvent, EventBean[] eventsPerStream, TableStateInstance tableStateInstance, TableOnMergeViewChangeHandler changeHandlerAdded, TableOnMergeViewChangeHandler changeHandlerRemoved, ExprEvaluatorContext exprEvaluatorContext)
        {
            tableStateInstance.DeleteEvent(matchingEvent);
            if (changeHandlerRemoved != null) {
                changeHandlerRemoved.Add(matchingEvent, eventsPerStream, false, exprEvaluatorContext);
            }
        }

        public override string Name
        {
            get { return "delete"; }
        }
    }
}
