///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2012 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////


using System;

namespace com.espertech.esper.pattern
{
    /// <summary>
    /// Interface for executing a Stop on an active event expression.
    /// </summary>
    public interface PatternStopCallback
    {
        void Stop();
    }

    public class ProxyPatternStopCallback : PatternStopCallback
    {
        public Action ProcStop { get; set; }

        /// <summary>
        /// Stops this instance.
        /// </summary>
        public void Stop()
        {
            ProcStop();
        }
    }
}
