///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2013 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using System;
using System.Text;

namespace com.espertech.esper.rowregex
{
    /// <summary>
    /// Or-condition in a regex expression tree.
    /// </summary>
    public class RowRegexExprNodeAlteration : RowRegexExprNode
    {
        /// <summary>
        /// Ctor.
        /// </summary>
        public RowRegexExprNodeAlteration()
        {        
        }
    
        public override String ToExpressionString()
        {
            StringBuilder builder = new StringBuilder();
            String delimiter = "";
            foreach (RowRegexExprNode node in this.ChildNodes)
            {
                builder.Append(delimiter);
                builder.Append(node.ToExpressionString());
                delimiter = "|";
            }
            return builder.ToString();
        }
    }
}
