///////////////////////////////////////////////////////////////////////////////////////
// Copyright (C) 2006-2012 Esper Team. All rights reserved.                           /
// http://esper.codehaus.org                                                          /
// ---------------------------------------------------------------------------------- /
// The software in this package is published under the terms of the GPL license       /
// a copy of which has been included with this distribution in the license.txt file.  /
///////////////////////////////////////////////////////////////////////////////////////

using System;

using com.espertech.esper.compat.logging;

namespace com.espertech.esper.rowregex
{
    /// <summary>
    /// Nested () regular expression in a regex expression tree.
    /// </summary>
    [Serializable]
    public class RowRegexExprNodeNested : RowRegexExprNode
    {
        private static readonly ILog Log = LogManager.GetLogger(System.Reflection.MethodBase.GetCurrentMethod().DeclaringType);

        /// <summary>
        /// Ctor.
        /// </summary>
        /// <param name="type">multiplicity and greedy</param>
        public RowRegexExprNodeNested(RegexNFATypeEnum type) {
            NFAType = type;
        }

        /// <summary>
        /// Returns multiplicity and greedy.
        /// </summary>
        /// <returns>
        /// type
        /// </returns>
        public RegexNFATypeEnum NFAType { get; private set; }

        public override String ToExpressionString()
        {
            return "(" + ChildNodes[0].ToExpressionString() + ")" + NFAType.OptionalPostfix();
        }
    }
}
